<?php
namespace nur\sery\schema;

abstract class Schema {
  /**
   * créer si besoin une nouvelle instance à partir d'une définition de schéma
   */
  static function new(&$md, $definition): self {
    if ($md === null) {
      if (AssocSchema::isa_definition($definition)) {
        $md = new AssocSchema($definition);
      } elseif (ListSchema::isa_definition($definition)) {
        $md = new ListSchema($definition);
      } elseif (ScalarSchema::isa_definition($definition)) {
        $md = new ScalarSchema($definition);
      } else {
        throw SchemaException::invalid_schema();
      }
    }
    return $md;
  }

  /**
   * @var array définition du schéma, à redéfinir le cas échéant dans une classe
   * dérivée
   */
  const SCHEMA = null;

  /** @var array */
  protected $definition;
}
